package io.zipcoder.interfaces;

import org.junit.Assert;
import org.junit.Test;

public class TestInstructor {

    @Test
    public void testImplementation(){
        Instructor instructor = new Instructor(54, "Mr.Bean");
        Assert.assertTrue(instructor instanceof Person);
    }

    @Test
    public void testInheritance(){
        Instructor instructor = new Instructor(54, "Mr.Bean");
        Assert.assertTrue(instructor instanceof Teacher);
    }

    @Test
    public void testTeach(){
        Instructor instructor = new Instructor(54, "Mr.Bean");
        Student student = new Student(1, "William");

        instructor.teach(student, 2);

        double expected = 2;
        double actual = student.totalStudyTime;

        Assert.assertEquals(expected, actual, 0);
    }

    @Test
    public void testLecture(){
        Instructor instructor = new Instructor(54, "Mr.Bean");
        Student William = new Student(1, "William");
        Student James = new Student(3, "James");

        Learner[] learners = {William, James};

        instructor.lecture(learners, 2);

        double expected = 1;
        double actualWilliam = William.totalStudyTime;
        double actualJames = James.totalStudyTime;

        Assert.assertEquals(expected, actualWilliam, 0);
        Assert.assertEquals(expected, actualJames, 0);
    }
}
