package io.zipcoder.interfaces;

import org.junit.Assert;
import org.junit.Test;

import java.util.ArrayList;

public class TestPeople {

//    public ArrayList<Person> buildPersonArray(){
//        People people = new People();
//        Person William = new Person(0, "William");
//        Person James = new Person(1, "James");
//        Person Alex = new Person(2, "Alex");
//        Person Stephanie = new Person(3, "Stephanie");
//
//        people.personList.add(William);
//        people.personList.add(James);
//        people.personList.add(Alex);
//        people.personList.add(Stephanie);
//
//        return people.personList;
//    }

    @Test
    public void testAdd(){
        People people = new People();
        Person William = new Person(1, "William");

        people.personList.add(William);

        int expected = 1;
        int actual = people.getCount();

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void testRemoveByPerson(){
        People people = new People();
        Person William = new Person(0, "William");
        Person James = new Person(1, "James");
        Person Alex = new Person(2, "Alex");
        Person Stephanie = new Person(3, "Stephanie");

        people.personList.add(William);
        people.personList.add(James);
        people.personList.add(Alex);
        people.personList.add(Stephanie);

        people.personList.remove(William);

        int expected = 3;
        int actual = people.personList.size();

        Assert.assertEquals(expected, actual);
    }

    @Test
    public void testRemoveById(){
        People people = new People();
        Person William = new Person(1, "William");
        Person James = new Person(2, "James");
        Person Alex = new Person(24, "Alex");
        Person Stephanie = new Person(32, "Stephanie");

        people.personList.add(William);
        people.personList.add(James);
        people.personList.add(Alex);
        people.personList.add(Stephanie);

        people.removeId(32);

        int expected = 3;
        int actual = people.personList.size();

        Assert.assertEquals(expected, actual);
        Assert.assertFalse(people.personList.contains(Stephanie));
    }

    @Test
    public void testFindById(){
        People people = new People();
        Person William = new Person(0, "William");
        Person James = new Person(1, "James");
        Person Alex = new Person(2, "Alex");
        Person Stephanie = new Person(3, "Stephanie");

        people.personList.add(William);
        people.personList.add(James);
        people.personList.add(Alex);
        people.personList.add(Stephanie);

        Person expected = William;
        Person actual = people.findById(0);

        Assert.assertEquals(expected, actual);
    }

    @Test
    public void testGetArray(){
        People people = new People();

        ArrayList<Person> PersonList = people.getPersonList();

        int expected = 0;
        int actual = people.personList.size();

        Assert.assertEquals(expected, actual);
    }

    @Test
    public void testRemoveAll(){
        People people = new People();
        Person William = new Person(0, "William");
        Person James = new Person(1, "James");
        Person Alex = new Person(2, "Alex");
        Person Stephanie = new Person(3, "Stephanie");

        people.personList.add(William);
        people.personList.add(James);
        people.personList.add(Alex);
        people.personList.add(Stephanie);

        people.removeAll();

        int expected = 0;
        int actual = people.personList.size();

        Assert.assertEquals(expected, actual);
    }
}
